net.minecraft.entity.player

## Class EntityPlayer

- java.lang.Object
- - net.minecraft.entity.Entity
  - - net.minecraft.entity.EntityLiving
    - - net.minecraft.entity.player.EntityPlayer

- All Implemented Interfaces:
    ICommandSender
  Direct Known Subclasses:
    EntityOtherPlayerMP, EntityPlayerMP, EntityPlayerSP, FakePlayer

      public abstract class EntityPlayer
      extends EntityLiving
      implements ICommandSender

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `float` | `cameraYaw`
    `PlayerCapabilities` | `capabilities` The player's capabilities.
    `float` | `experience` The current amount of experience the player has within their Experience Bar.
    `int` | `experienceLevel` The current experience level the player is on.
    `int` | `experienceTotal` The total amount of experience the player has.
    `float` | `field_71079_bU`
    `float` | `field_71082_cx`
    `double` | `field_71085_bR`
    `float` | `field_71089_bV`
    `double` | `field_71091_bM`
    `double` | `field_71094_bP`
    `double` | `field_71095_bQ`
    `double` | `field_71096_bN`
    `double` | `field_71097_bO`
    `byte` | `field_71098_bD`
    `EntityFishHook` | `fishEntity` An instance of a fishing rod's hook.
    `InventoryPlayer` | `inventory` Inventory of the player
    `Container` | `inventoryContainer` The Container for the player's inventory (which opens when they press E)
    `int` | `maxHealth`
    `Container` | `openContainer` The Container the player has open.
    `static String` | `PERSISTED_NBT_TAG`
    `ChunkCoordinates` | `playerLocation` The chunk coordinates of the bed the player is in (null if player isn't in a bed).
    `float` | `prevCameraYaw`
    `int` | `sleepTimer`
    `String` | `username`
    `int` | `xpCooldown` Used by EntityPlayer to prevent too many xp orbs from getting absorbed at once.

    - ### Fields inherited from class net.minecraft.entity.EntityLiving

      `arrowHitTimer, attackedAtYaw, attackTime, cameraPitch, carryoverDamage, deathTime, experienceValue, field_70730_aX, field_70731_aW, field_70769_ao, field_70770_ap, field_94063_bt, hurtTime, isJumping, isSwingInProgress, jumpMovementFactor, landMovementFactor, limbSwing, limbYaw, livingSoundTime, maxHurtResistantTime, maxHurtTime, pickUpLootProability, prevCameraPitch, prevHealth, prevLimbYaw, prevRenderYawOffset, prevRotationYawHead, prevSwingProgress, renderYawOffset, rotationYawHead, swingProgress, swingProgressInt, targetTasks, tasks`

    - ### Fields inherited from class net.minecraft.entity.Entity

      `addedToChunk, boundingBox, capturedDrops, captureDrops, chunkCoordX, chunkCoordY, chunkCoordZ, cloakUrl, dimension, distanceWalkedModified, distanceWalkedOnStepModified, entityCollisionReduction, entityId, fallDistance, field_70135_K, field_98038_p, fireResistance, height, hurtResistantTime, ignoreFrustumCheck, isAirBorne, isCollided, isCollidedHorizontally, isCollidedVertically, isDead, lastTickPosX, lastTickPosY, lastTickPosZ, motionX, motionY, motionZ, myEntitySize, noClip, onGround, posX, posY, posZ, prevDistanceWalkedModified, preventEntitySpawning, prevPosX, prevPosY, prevPosZ, prevRotationPitch, prevRotationYaw, renderDistanceWeight, riddenByEntity, ridingEntity, rotationPitch, rotationYaw, serverPosX, serverPosY, serverPosZ, skinUrl, stepHeight, ticksExisted, timeUntilPortal, velocityChanged, width, worldObj, yOffset, ySize`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EntityPlayer(World par1World)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addChatMessage(String par1Str)` Add a chat message to the player
    `void` | `addExhaustion(float par1)` increases exhaustion level by supplied amount
    `void` | `addExperience(int par1)` This method increases the player's current amount of experience.
    `void` | `addExperienceLevel(int par1)` Add experience levels to this player.
    `void` | `addMovementStat(double par1, double par3, double par5)` Adds a value to a movement statistic field - like run, walk, swin or climb.
    `void` | `addScore(int par1)` Add to player's score
    `void` | `addStat(StatBase par1StatBase, int par2)` Adds a value to a statistic field.
    `void` | `addToPlayerScore(Entity par1Entity, int par2)` Adds a value to the player score.
    `boolean` | `attackEntityFrom(DamageSource par1DamageSource, int par2)` Called when the entity is attacked.
    `void` | `attackTargetEntityWithCurrentItem(Entity par1Entity)` Attacks for the player the targeted entity with the currently equipped item.
    `boolean` | `canCurrentToolHarvestBlock(int par1, int par2, int par3)` Returns true if the item the player is holding can harvest the block at the given coords.
    `boolean` | `canEat(boolean par1)`
    `boolean` | `canHarvestBlock(Block par1Block)` Checks if the player has the ability to harvest a block (checks current inventory item for a tool if necessary)
    `boolean` | `canPickUpLoot()`
    `boolean` | `canPlayerEdit(int par1, int par2, int par3, int par4, ItemStack par5ItemStack)`
    `void` | `clearItemInUse()`
    `void` | `clonePlayer(EntityPlayer par1EntityPlayer, boolean par2)` Copies the values from the given player into this player if boolean par2 is true.
    `void` | `closeScreen()` sets current screen to null (used on escape buttons of GUIs)
    `void` | `destroyCurrentEquippedItem()` Destroys the currently equipped item from the player's inventory.
    `void` | `displayGUIAnvil(int par1, int par2, int par3)` Displays the GUI for interacting with an anvil.
    `void` | `displayGUIBeacon(TileEntityBeacon par1TileEntityBeacon)` Displays the GUI for interacting with a beacon.
    `void` | `displayGUIBook(ItemStack par1ItemStack)` Displays the GUI for interacting with a book.
    `void` | `displayGUIBrewingStand(TileEntityBrewingStand par1TileEntityBrewingStand)` Displays the GUI for interacting with a brewing stand.
    `void` | `displayGUIChest(IInventory par1IInventory)` Displays the GUI for interacting with a chest inventory.
    `void` | `displayGUIDispenser(TileEntityDispenser par1TileEntityDispenser)` Displays the dipsenser GUI for the passed in dispenser entity.
    `void` | `displayGUIEditSign(TileEntity par1TileEntity)` Displays the GUI for editing a sign.
    `void` | `displayGUIEnchantment(int par1, int par2, int par3, String par4Str)`
    `void` | `displayGUIFurnace(TileEntityFurnace par1TileEntityFurnace)` Displays the furnace GUI for the passed in furnace entity.
    `void` | `displayGUIHopper(TileEntityHopper par1TileEntityHopper)`
    `void` | `displayGUIHopperMinecart(EntityMinecartHopper par1EntityMinecartHopper)`
    `void` | `displayGUIMerchant(IMerchant par1IMerchant, String par2Str)`
    `void` | `displayGUIWorkbench(int par1, int par2, int par3)` Displays the crafting GUI for a workbench.
    `EntityItem` | `dropOneItem(boolean par1)` Called when player presses the drop item key
    `EntityItem` | `dropPlayerItem(ItemStack par1ItemStack)` Args: itemstack - called when player drops an item stack that's not in his inventory (like items still placed in a workbench while the workbench'es GUI gets closed)
    `EntityItem` | `dropPlayerItemWithRandomChoice(ItemStack par1ItemStack, boolean par2)` Args: itemstack, flag
    `boolean` | `func_71066_bF()`
    `float` | `func_82243_bO()`
    `boolean` | `func_94059_bO()`
    `boolean` | `func_94062_bN()`
    `boolean` | `func_96092_aw()`
    `boolean` | `func_96122_a(EntityPlayer par1EntityPlayer)`
    `boolean` | `func_98034_c(EntityPlayer par1EntityPlayer)`
    `ChunkCoordinates` | `getBedLocation()` Returns the location of the bed the player will respawn at, or null if the player has not slept in a bed.
    `float` | `getBedOrientationInDegrees()`
    `String` | `getCommandSenderName()` Gets the name of this command sender (usually username, but possibly "Rcon")
    `ItemStack` | `getCurrentArmor(int par1)`
    `ItemStack` | `getCurrentEquippedItem()` Returns the currently being used item by the player.
    `ItemStack` | `getCurrentItemOrArmor(int par1)` 0 = item, 1-n is armor
    `float` | `getCurrentPlayerStrVsBlock(Block par1Block, boolean par2)` Deprecated.
    `float` | `getCurrentPlayerStrVsBlock(Block par1Block, boolean par2, int meta)`
    `String` | `getEntityName()` Gets the username of the entity.
    `float` | `getEyeHeight()`
    `FoodStats` | `getFoodStats()` Returns the player's FoodStats object.
    `ItemStack` | `getHeldItem()` Returns the item that this EntityLiving is holding, if any.
    `boolean` | `getHideCape()`
    `InventoryEnderChest` | `getInventoryEnderChest()` Returns the InventoryEnderChest of this player.
    `Icon` | `getItemIcon(ItemStack par1ItemStack, int par2)`
    `ItemStack` | `getItemInUse()`
    `int` | `getItemInUseCount()`
    `int` | `getItemInUseDuration()`
    `ItemStack[]` | `getLastActiveItems()`
    `int` | `getMaxHealth()`
    `int` | `getMaxInPortalTime()` Return the amount of time this entity should stay in a portal before being transported.
    `int` | `getPortalCooldown()` Return the amount of cooldown before this entity can use a portal again.
    `int` | `getScore()`
    `int` | `getSleepTimer()`
    `ScorePlayerTeam` | `getTeam()`
    `int` | `getTotalArmorValue()` Returns the current armor value as determined by a call to InventoryPlayer.getTotalArmorValue
    `String` | `getTranslatedEntityName()` Returns the translated name of the entity.
    `StringTranslate` | `getTranslator()`
    `Scoreboard` | `getWorldScoreboard()`
    `double` | `getYOffset()` Returns the Y Offset of this entity.
    `void` | `handleHealthUpdate(byte par1)`
    `boolean` | `interactWith(Entity par1Entity)`
    `boolean` | `isBlocking()`
    `boolean` | `isEntityInsideOpaqueBlock()` Checks if this entity is inside of an opaque block
    `boolean` | `isPlayerFullyAsleep()` Returns whether or not the player is asleep and the screen has fully faded.
    `boolean` | `isPlayerSleeping()` Returns whether player is sleeping or not
    `boolean` | `isSpawnForced()`
    `boolean` | `isUsingItem()` Checks if the entity is currently using an item (e.g., bow, food, sword) by holding down the useItemButton
    `void` | `joinEntityItemWithWorld(EntityItem par1EntityItem)` Joins the passed in entity item with the world.
    `void` | `mountEntity(Entity par1Entity)` Called when a player mounts an entity.
    `void` | `moveEntityWithHeading(float par1, float par2)` Moves the entity based on the specified heading.
    `void` | `onCriticalHit(Entity par1Entity)` Called when the player performs a critical hit on the Entity.
    `void` | `onDeath(DamageSource par1DamageSource)` Called when the mob's health reaches 0.
    `void` | `onEnchantmentCritical(Entity par1Entity)`
    `void` | `onKillEntity(EntityLiving par1EntityLiving)` This method gets called when the entity kills another one.
    `void` | `onLivingUpdate()` Called frequently so the entity can update its state every tick as required.
    `void` | `onUpdate()` Called to update the entity's position/logic.
    `void` | `openGui(Object mod, int modGuiId, World world, int x, int y, int z)`
    `void` | `playSound(String par1Str, float par2, float par3)`
    `void` | `preparePlayerToSpawn()`
    `void` | `readEntityFromNBT(NBTTagCompound par1NBTTagCompound)` (abstract) Protected helper method to read subclass entity data from NBT.
    `void` | `respawnPlayer()`
    `void` | `sendPlayerAbilities()` Sends the player's abilities to the server (if there is one).
    `void` | `setCurrentItemOrArmor(int par1, ItemStack par2ItemStack)` Sets the held item, or an armor slot.
    `void` | `setDead()` Will get destroyed next tick.
    `void` | `setGameType(EnumGameType par1EnumGameType)` Sets the player's game mode and sends it to them.
    `void` | `setInWeb()` Sets the Entity inside a web block.
    `void` | `setItemInUse(ItemStack par1ItemStack, int par2)` sets the itemInUse when the use item button is clicked.
    `void` | `setScore(int par1)` Set player's score
    `void` | `setSpawnChunk(ChunkCoordinates par1ChunkCoordinates, boolean par2)` Defines a spawn coordinate to player spawn.
    `boolean` | `shouldHeal()` Checks if the player's health is not full and not zero.
    `EnumStatus` | `sleepInBedAt(int par1, int par2, int par3)` Attempts to have the player sleep in a bed at the specified location.
    `void` | `stopUsingItem()`
    `String` | `translateString(String par1Str, Object... par2ArrayOfObj)` Translates and formats the given string key with the given arguments.
    `void` | `triggerAchievement(StatBase par1StatBase)` Will trigger the specified trigger.
    `void` | `updateRidden()` Handles updating while being ridden by an entity
    `static ChunkCoordinates` | `verifyRespawnCoordinates(World par0World, ChunkCoordinates par1ChunkCoordinates, boolean par2)` Ensure that a block enabling respawning exists at the specified coordinates and find an empty space nearby to spawn.
    `void` | `wakeUpPlayer(boolean par1, boolean par2, boolean par3)` Wake up the player if they're sleeping.
    `void` | `writeEntityToNBT(NBTTagCompound par1NBTTagCompound)` (abstract) Protected helper method to write subclass entity data to NBT.
    `int` | `xpBarCap()` This method returns the cap amount of experience that the experience bar can hold.

    - ### Methods inherited from class net.minecraft.entity.EntityLiving

      `addPotionEffect, attackEntityAsMob, canAttackClass, canBeCollidedWith, canBePushed, canBeSteered, canBreatheUnderwater, canEntityBeSeen, clearActivePotions, curePotionEffects, detachHome, eatGrassBonus, faceEntity, func_104002_bU, func_82143_as, func_94056_bM, func_94057_bL, func_94058_c, func_94060_bK, func_94061_f, func_96120_a, getActivePotionEffect, getActivePotionEffects, getAge, getAIMoveSpeed, getAITarget, getArmorItemForSlot, getArmorPosition, getArrowCountInEntity, getAttackTarget, getCanSpawnHere, getCreatureAttribute, getEntitySenses, getHealth, getHomePosition, getJumpHelper, getLastAttackingEntity, getLook, getLookHelper, getLookVec, getMaximumHomeDistance, getMaxSpawnedInChunk, getMoveHelper, getNavigator, getPosition, getRenderSizeModifier, getRNG, getRotationYawHead, getSpeedModifier, getSwingProgress, getTalkInterval, getTexture, getVerticalFaceSpeed, hasHome, heal, initCreature, isChild, isEntityAlive, isEntityUndead, isOnLadder, isPotionActive, isPotionActive, isPotionApplicable, isWithinHomeDistance, isWithinHomeDistanceCurrentPosition, knockBack, onEntityUpdate, onItemPickup, performHurtAnimation, playLivingSound, rayTrace, removePotionEffect, removePotionEffectClient, renderBrokenItemStack, setAIMoveSpeed, setArrowCountInEntity, setAttackTarget, setCanPickUpLoot, setEntityHealth, setHomeArea, setJumping, setLastAttackingEntity, setMoveForward, setPositionAndRotation2, setPositionAndUpdate, setRevengeTarget, setRotationYawHead, shouldRiderFaceForward, spawnExplosionParticle, swingItem`

    - ### Methods inherited from class net.minecraft.entity.Entity

      `addEntityID, addNotRiddenEntityID, addVelocity, applyEntityCollision, canAttackWithItem, canRenderOnFire, copyDataFrom, doesEntityNotTriggerPressurePlate, dropItem, dropItemWithOffset, entityDropItem, equals, extinguish, func_82146_a, func_82149_j, func_85029_a, func_85031_j, func_96091_a, getAir, getBoundingBox, getBrightness, getBrightnessForRender, getCollisionBorderSize, getCollisionBox, getDataWatcher, getDistance, getDistanceSq, getDistanceSqToEntity, getDistanceToEntity, getEntityData, getExtendedProperties, getMountedYOffset, getParts, getPersistentID, getPickedResult, getShadowSize, getTeleportDirection, handleLavaMovement, handleWaterMovement, hashCode, interact, isBurning, isCreatureType, isEating, isEntityEqual, isEntityInvulnerable, isImmuneToFire, isInRangeToRenderDist, isInRangeToRenderVec3D, isInsideOfMaterial, isInvisible, isInWater, isOffsetPositionInLiquid, isRiding, isSneaking, isSprinting, isWet, moveEntity, moveFlying, onCollideWithPlayer, onStruckByLightning, readFromNBT, registerExtendedProperties, resetEntityId, setAir, setAngles, setEating, setFire, setInPortal, setInvisible, setLocationAndAngles, setPosition, setPositionAndRotation, setSneaking, setSprinting, setVelocity, setWorld, shouldRenderInPass, shouldRiderSit, toString, travelToDimension, unmountEntity, updateCloak, updateRiderPosition, writeToNBT`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.minecraft.command.ICommandSender

      `canCommandSenderUseCommand, getPlayerCoordinates, sendChatToPlayer`

- - ### Field Detail

    - #### PERSISTED_NBT_TAG

          public static final String PERSISTED_NBT_TAG

      See Also:
        Constant Field Values

    - #### maxHealth

          public int maxHealth

    - #### inventory

          public InventoryPlayer inventory

      Inventory of the player

    - #### inventoryContainer

          public Container inventoryContainer

      The Container for the player's inventory (which opens when they press E)

    - #### openContainer

          public Container openContainer

      The Container the player has open.

    - #### field_71098_bD

          public byte field_71098_bD

    - #### prevCameraYaw

          public float prevCameraYaw

    - #### cameraYaw

          public float cameraYaw

    - #### username

          public String username

    - #### xpCooldown

          public int xpCooldown

      Used by EntityPlayer to prevent too many xp orbs from getting absorbed at once.

    - #### field_71091_bM

          public double field_71091_bM

    - #### field_71096_bN

          public double field_71096_bN

    - #### field_71097_bO

          public double field_71097_bO

    - #### field_71094_bP

          public double field_71094_bP

    - #### field_71095_bQ

          public double field_71095_bQ

    - #### field_71085_bR

          public double field_71085_bR

    - #### playerLocation

          public ChunkCoordinates playerLocation

      The chunk coordinates of the bed the player is in (null if player isn't in a bed).

    - #### sleepTimer

          public int sleepTimer

    - #### field_71079_bU

          public float field_71079_bU

    - #### field_71082_cx

          public float field_71082_cx

    - #### field_71089_bV

          public float field_71089_bV

    - #### capabilities

          public PlayerCapabilities capabilities

      The player's capabilities. (See class PlayerCapabilities)

    - #### experienceLevel

          public int experienceLevel

      The current experience level the player is on.

    - #### experienceTotal

          public int experienceTotal

      The total amount of experience the player has. This also includes the amount of experience within their Experience Bar.

    - #### experience

          public float experience

      The current amount of experience the player has within their Experience Bar.

    - #### fishEntity

          public EntityFishHook fishEntity

      An instance of a fishing rod's hook. If this isn't null, the icon image of the fishing rod is slightly different

  - ### Constructor Detail

    - #### EntityPlayer

          public EntityPlayer(World par1World)

  - ### Method Detail

    - #### getMaxHealth

          public int getMaxHealth()

      Specified by:
        `getMaxHealth` in class `EntityLiving`

    - #### getItemInUse

          public ItemStack getItemInUse()

    - #### getItemInUseCount

          public int getItemInUseCount()

    - #### isUsingItem

          public boolean isUsingItem()

      Checks if the entity is currently using an item (e.g., bow, food, sword) by holding down the useItemButton

    - #### getItemInUseDuration

          public int getItemInUseDuration()

    - #### stopUsingItem

          public void stopUsingItem()

    - #### clearItemInUse

          public void clearItemInUse()

    - #### isBlocking

          public boolean isBlocking()

      Overrides:
        `isBlocking` in class `EntityLiving`

    - #### onUpdate

          public void onUpdate()

      Called to update the entity's position/logic.
      Overrides:
        `onUpdate` in class `EntityLiving`

    - #### getMaxInPortalTime

          public int getMaxInPortalTime()

      Return the amount of time this entity should stay in a portal before being transported.
      Overrides:
        `getMaxInPortalTime` in class `Entity`

    - #### getPortalCooldown

          public int getPortalCooldown()

      Return the amount of cooldown before this entity can use a portal again.
      Overrides:
        `getPortalCooldown` in class `Entity`

    - #### playSound

          public void playSound(String par1Str,
                       float par2,
                       float par3)

      Overrides:
        `playSound` in class `Entity`

    - #### handleHealthUpdate

          public void handleHealthUpdate(byte par1)

      Overrides:
        `handleHealthUpdate` in class `EntityLiving`

    - #### closeScreen

          public void closeScreen()

      sets current screen to null (used on escape buttons of GUIs)

    - #### mountEntity

          public void mountEntity(Entity par1Entity)

      Called when a player mounts an entity. e.g. mounts a pig, mounts a boat.
      Overrides:
        `mountEntity` in class `Entity`

    - #### updateRidden

          public void updateRidden()

      Handles updating while being ridden by an entity
      Overrides:
        `updateRidden` in class `EntityLiving`

    - #### preparePlayerToSpawn

          public void preparePlayerToSpawn()

    - #### onLivingUpdate

          public void onLivingUpdate()

      Called frequently so the entity can update its state every tick as required. For example, zombies and skeletons use this to react to sunlight and start to burn.
      Overrides:
        `onLivingUpdate` in class `EntityLiving`

    - #### getScore

          public int getScore()

    - #### setScore

          public void setScore(int par1)

      Set player's score

    - #### addScore

          public void addScore(int par1)

      Add to player's score

    - #### onDeath

          public void onDeath(DamageSource par1DamageSource)

      Called when the mob's health reaches 0.
      Overrides:
        `onDeath` in class `EntityLiving`

    - #### addToPlayerScore

          public void addToPlayerScore(Entity par1Entity,
                              int par2)

      Adds a value to the player score. Currently not actually used and the entity passed in does nothing. Args: entity, scoreToAdd
      Overrides:
        `addToPlayerScore` in class `Entity`

    - #### dropOneItem

          public EntityItem dropOneItem(boolean par1)

      Called when player presses the drop item key

    - #### dropPlayerItem

          public EntityItem dropPlayerItem(ItemStack par1ItemStack)

      Args: itemstack - called when player drops an item stack that's not in his inventory (like items still placed in a workbench while the workbench'es GUI gets closed)

    - #### dropPlayerItemWithRandomChoice

          public EntityItem dropPlayerItemWithRandomChoice(ItemStack par1ItemStack,
                                                  boolean par2)

      Args: itemstack, flag

    - #### joinEntityItemWithWorld

          public void joinEntityItemWithWorld(EntityItem par1EntityItem)

      Joins the passed in entity item with the world. Args: entityItem

    - #### getCurrentPlayerStrVsBlock

          @Deprecated
          public float getCurrentPlayerStrVsBlock(Block par1Block,
                                                    boolean par2)

      Deprecated.
      Returns how strong the player is against the specified block at this moment Deprecated in favor of the more sensitive version

    - #### getCurrentPlayerStrVsBlock

          public float getCurrentPlayerStrVsBlock(Block par1Block,
                                         boolean par2,
                                         int meta)

    - #### canHarvestBlock

          public boolean canHarvestBlock(Block par1Block)

      Checks if the player has the ability to harvest a block (checks current inventory item for a tool if necessary)

    - #### readEntityFromNBT

          public void readEntityFromNBT(NBTTagCompound par1NBTTagCompound)

      (abstract) Protected helper method to read subclass entity data from NBT.
      Overrides:
        `readEntityFromNBT` in class `EntityLiving`

    - #### writeEntityToNBT

          public void writeEntityToNBT(NBTTagCompound par1NBTTagCompound)

      (abstract) Protected helper method to write subclass entity data to NBT.
      Overrides:
        `writeEntityToNBT` in class `EntityLiving`

    - #### displayGUIChest

          public void displayGUIChest(IInventory par1IInventory)

      Displays the GUI for interacting with a chest inventory. Args: chestInventory

    - #### displayGUIHopper

          public void displayGUIHopper(TileEntityHopper par1TileEntityHopper)

    - #### displayGUIHopperMinecart

          public void displayGUIHopperMinecart(EntityMinecartHopper par1EntityMinecartHopper)

    - #### displayGUIEnchantment

          public void displayGUIEnchantment(int par1,
                                   int par2,
                                   int par3,
                                   String par4Str)

    - #### displayGUIAnvil

          public void displayGUIAnvil(int par1,
                             int par2,
                             int par3)

      Displays the GUI for interacting with an anvil.

    - #### displayGUIWorkbench

          public void displayGUIWorkbench(int par1,
                                 int par2,
                                 int par3)

      Displays the crafting GUI for a workbench.

    - #### getEyeHeight

          public float getEyeHeight()

      Overrides:
        `getEyeHeight` in class `EntityLiving`

    - #### attackEntityFrom

          public boolean attackEntityFrom(DamageSource par1DamageSource,
                                 int par2)

      Called when the entity is attacked.
      Overrides:
        `attackEntityFrom` in class `EntityLiving`

    - #### func_96122_a

          public boolean func_96122_a(EntityPlayer par1EntityPlayer)

    - #### getTotalArmorValue

          public int getTotalArmorValue()

      Returns the current armor value as determined by a call to InventoryPlayer.getTotalArmorValue
      Overrides:
        `getTotalArmorValue` in class `EntityLiving`

    - #### func_82243_bO

          public float func_82243_bO()

    - #### displayGUIFurnace

          public void displayGUIFurnace(TileEntityFurnace par1TileEntityFurnace)

      Displays the furnace GUI for the passed in furnace entity. Args: tileEntityFurnace

    - #### displayGUIDispenser

          public void displayGUIDispenser(TileEntityDispenser par1TileEntityDispenser)

      Displays the dipsenser GUI for the passed in dispenser entity. Args: TileEntityDispenser

    - #### displayGUIEditSign

          public void displayGUIEditSign(TileEntity par1TileEntity)

      Displays the GUI for editing a sign. Args: tileEntitySign

    - #### displayGUIBrewingStand

          public void displayGUIBrewingStand(TileEntityBrewingStand par1TileEntityBrewingStand)

      Displays the GUI for interacting with a brewing stand.

    - #### displayGUIBeacon

          public void displayGUIBeacon(TileEntityBeacon par1TileEntityBeacon)

      Displays the GUI for interacting with a beacon.

    - #### displayGUIMerchant

          public void displayGUIMerchant(IMerchant par1IMerchant,
                                String par2Str)

    - #### displayGUIBook

          public void displayGUIBook(ItemStack par1ItemStack)

      Displays the GUI for interacting with a book.

    - #### interactWith

          public boolean interactWith(Entity par1Entity)

    - #### getCurrentEquippedItem

          public ItemStack getCurrentEquippedItem()

      Returns the currently being used item by the player.

    - #### destroyCurrentEquippedItem

          public void destroyCurrentEquippedItem()

      Destroys the currently equipped item from the player's inventory.

    - #### getYOffset

          public double getYOffset()

      Returns the Y Offset of this entity.
      Overrides:
        `getYOffset` in class `Entity`

    - #### attackTargetEntityWithCurrentItem

          public void attackTargetEntityWithCurrentItem(Entity par1Entity)

      Attacks for the player the targeted entity with the currently equipped item. The equipped item has hitEntity called on it. Args: targetEntity

    - #### onCriticalHit

          public void onCriticalHit(Entity par1Entity)

      Called when the player performs a critical hit on the Entity. Args: entity that was hit critically

    - #### onEnchantmentCritical

          public void onEnchantmentCritical(Entity par1Entity)

    - #### respawnPlayer

          public void respawnPlayer()

    - #### setDead

          public void setDead()

      Will get destroyed next tick.
      Overrides:
        `setDead` in class `Entity`

    - #### isEntityInsideOpaqueBlock

          public boolean isEntityInsideOpaqueBlock()

      Checks if this entity is inside of an opaque block
      Overrides:
        `isEntityInsideOpaqueBlock` in class `Entity`

    - #### func_71066_bF

          public boolean func_71066_bF()

    - #### sleepInBedAt

          public EnumStatus sleepInBedAt(int par1,
                                int par2,
                                int par3)

      Attempts to have the player sleep in a bed at the specified location.

    - #### wakeUpPlayer

          public void wakeUpPlayer(boolean par1,
                          boolean par2,
                          boolean par3)

      Wake up the player if they're sleeping.

    - #### verifyRespawnCoordinates

          public static ChunkCoordinates verifyRespawnCoordinates(World par0World,
                                                  ChunkCoordinates par1ChunkCoordinates,
                                                  boolean par2)

      Ensure that a block enabling respawning exists at the specified coordinates and find an empty space nearby to spawn.

    - #### getBedOrientationInDegrees

          public float getBedOrientationInDegrees()

    - #### isPlayerSleeping

          public boolean isPlayerSleeping()

      Returns whether player is sleeping or not
      Overrides:
        `isPlayerSleeping` in class `EntityLiving`

    - #### isPlayerFullyAsleep

          public boolean isPlayerFullyAsleep()

      Returns whether or not the player is asleep and the screen has fully faded.

    - #### getSleepTimer

          public int getSleepTimer()

    - #### addChatMessage

          public void addChatMessage(String par1Str)

      Add a chat message to the player

    - #### getBedLocation

          public ChunkCoordinates getBedLocation()

      Returns the location of the bed the player will respawn at, or null if the player has not slept in a bed.

    - #### isSpawnForced

          public boolean isSpawnForced()

    - #### setSpawnChunk

          public void setSpawnChunk(ChunkCoordinates par1ChunkCoordinates,
                           boolean par2)

      Defines a spawn coordinate to player spawn. Used by bed after the player sleep on it.

    - #### triggerAchievement

          public void triggerAchievement(StatBase par1StatBase)

      Will trigger the specified trigger.

    - #### addStat

          public void addStat(StatBase par1StatBase,
                     int par2)

      Adds a value to a statistic field.

    - #### moveEntityWithHeading

          public void moveEntityWithHeading(float par1,
                                   float par2)

      Moves the entity based on the specified heading. Args: strafe, forward
      Overrides:
        `moveEntityWithHeading` in class `EntityLiving`

    - #### addMovementStat

          public void addMovementStat(double par1,
                             double par3,
                             double par5)

      Adds a value to a movement statistic field - like run, walk, swin or climb.

    - #### onKillEntity

          public void onKillEntity(EntityLiving par1EntityLiving)

      This method gets called when the entity kills another one.
      Overrides:
        `onKillEntity` in class `Entity`

    - #### setInWeb

          public void setInWeb()

      Sets the Entity inside a web block.
      Overrides:
        `setInWeb` in class `Entity`

    - #### getItemIcon

          public Icon getItemIcon(ItemStack par1ItemStack,
                         int par2)

      Overrides:
        `getItemIcon` in class `EntityLiving`

    - #### getCurrentArmor

          public ItemStack getCurrentArmor(int par1)

      Overrides:
        `getCurrentArmor` in class `EntityLiving`

    - #### addExperience

          public void addExperience(int par1)

      This method increases the player's current amount of experience.

    - #### addExperienceLevel

          public void addExperienceLevel(int par1)

      Add experience levels to this player.

    - #### xpBarCap

          public int xpBarCap()

      This method returns the cap amount of experience that the experience bar can hold. With each level, the experience cap on the player's experience bar is raised by 10.

    - #### addExhaustion

          public void addExhaustion(float par1)

      increases exhaustion level by supplied amount

    - #### getFoodStats

          public FoodStats getFoodStats()

      Returns the player's FoodStats object.

    - #### canEat

          public boolean canEat(boolean par1)

    - #### shouldHeal

          public boolean shouldHeal()

      Checks if the player's health is not full and not zero.

    - #### setItemInUse

          public void setItemInUse(ItemStack par1ItemStack,
                          int par2)

      sets the itemInUse when the use item button is clicked. Args: itemstack, int maxItemUseDuration

    - #### canCurrentToolHarvestBlock

          public boolean canCurrentToolHarvestBlock(int par1,
                                           int par2,
                                           int par3)

      Returns true if the item the player is holding can harvest the block at the given coords. Args: x, y, z.

    - #### canPlayerEdit

          public boolean canPlayerEdit(int par1,
                              int par2,
                              int par3,
                              int par4,
                              ItemStack par5ItemStack)

    - #### getEntityName

          public String getEntityName()

      Gets the username of the entity.
      Overrides:
        `getEntityName` in class `EntityLiving`

    - #### func_94062_bN

          public boolean func_94062_bN()

      Overrides:
        `func_94062_bN` in class `EntityLiving`

    - #### func_94059_bO

          public boolean func_94059_bO()

      Overrides:
        `func_94059_bO` in class `EntityLiving`

    - #### canPickUpLoot

          public boolean canPickUpLoot()

      Overrides:
        `canPickUpLoot` in class `EntityLiving`

    - #### clonePlayer

          public void clonePlayer(EntityPlayer par1EntityPlayer,
                         boolean par2)

      Copies the values from the given player into this player if boolean par2 is true. Always clones Ender Chest Inventory.

    - #### sendPlayerAbilities

          public void sendPlayerAbilities()

      Sends the player's abilities to the server (if there is one).

    - #### setGameType

          public void setGameType(EnumGameType par1EnumGameType)

      Sets the player's game mode and sends it to them.

    - #### getCommandSenderName

          public String getCommandSenderName()

      Gets the name of this command sender (usually username, but possibly "Rcon")
      Specified by:
        `getCommandSenderName` in interface `ICommandSender`

    - #### getTranslator

          public StringTranslate getTranslator()

    - #### translateString

          public String translateString(String par1Str,
                               Object... par2ArrayOfObj)

      Translates and formats the given string key with the given arguments.
      Specified by:
        `translateString` in interface `ICommandSender`

    - #### getInventoryEnderChest

          public InventoryEnderChest getInventoryEnderChest()

      Returns the InventoryEnderChest of this player.

    - #### getCurrentItemOrArmor

          public ItemStack getCurrentItemOrArmor(int par1)

      0 = item, 1-n is armor
      Overrides:
        `getCurrentItemOrArmor` in class `EntityLiving`

    - #### getHeldItem

          public ItemStack getHeldItem()

      Returns the item that this EntityLiving is holding, if any.
      Overrides:
        `getHeldItem` in class `EntityLiving`

    - #### setCurrentItemOrArmor

          public void setCurrentItemOrArmor(int par1,
                                   ItemStack par2ItemStack)

      Sets the held item, or an armor slot. Slot 0 is held item. Slot 1-4 is armor. Params: Item, slot
      Overrides:
        `setCurrentItemOrArmor` in class `EntityLiving`

    - #### func_98034_c

          public boolean func_98034_c(EntityPlayer par1EntityPlayer)

      Overrides:
        `func_98034_c` in class `Entity`

    - #### getLastActiveItems

          public ItemStack[] getLastActiveItems()

      Overrides:
        `getLastActiveItems` in class `EntityLiving`

    - #### getHideCape

          public boolean getHideCape()

    - #### func_96092_aw

          public boolean func_96092_aw()

      Overrides:
        `func_96092_aw` in class `Entity`

    - #### getWorldScoreboard

          public Scoreboard getWorldScoreboard()

    - #### getTeam

          public ScorePlayerTeam getTeam()

    - #### getTranslatedEntityName

          public String getTranslatedEntityName()

      Returns the translated name of the entity.
      Overrides:
        `getTranslatedEntityName` in class `Entity`

    - #### openGui

          public void openGui(Object mod,
                     int modGuiId,
                     World world,
                     int x,
                     int y,
                     int z)